Bug 1213111 - Review Request: docker-compose - Punctual, lightweight development environments using Docker
Summary: Review Request: docker-compose - Punctual, lightweight development environmen...
Keywords:
Status: CLOSED NEXTRELEASE
Alias: None
Product: Fedora
Classification: Fedora
Component: Package Review
Version: rawhide
Hardware: All
OS: Linux
unspecified
medium
Target Milestone: ---
Assignee: Marek Goldmann
QA Contact: Fedora Extras Quality Assurance
URL:
Whiteboard:
Depends On: 1253859
Blocks:
TreeView+ depends on / blocked
 
Reported: 2015-04-18 23:55 UTC by Michael Hampton
Modified: 2015-09-06 17:06 UTC (History)
6 users (show)

Fixed In Version: 1.4.0-1.fc23
Doc Type: Bug Fix
Doc Text:
Clone Of:
Environment:
Last Closed: 2015-09-06 01:11:13 UTC
Type: ---
mgoldman: fedora-review+
gwync: fedora-cvs+


Attachments (Terms of Use)


Links
System ID Priority Status Summary Last Updated
Red Hat Bugzilla 1151072 None None None Never

Internal Links: 1151072

Description Michael Hampton 2015-04-18 23:55:03 UTC
Spec URL: https://dl.dropboxusercontent.com/u/24777749/docker-compose.spec
SRPM URL: https://dl.dropboxusercontent.com/u/24777749/docker-compose-1.2.0-1.fc21.src.rpm
Scratch build: https://copr.fedoraproject.org/coprs/error/docker-compose/build/86795/
Description:

This is a review request for docker-compose, to replace and obsolete the existing package fig. Upstream has renamed this package.

For further background see bug 1204441

The spec file is based on fig.spec from the existing package, but I've also taken the opportunity to do a little cleanup. It is now properly a noarch package, has a missing doc file added, and a few extra comments sprinkled throughout the spec file.

The package also no longer requires docker, as docker-compose can now communicate with docker via its remote API, and docker need not be installed on the same system as docker-compose. This was a new feature introduced at the same time as the name change.

rpmlint output:
$ rpmlint docker-compose.spec /var/lib/mock/fedora-21-x86_64/result/docker-compose-1.2.0-1.fc21.src.rpm /var/lib/mock/fedora-21-x86_64/result/docker-compose-1.2.0-1.fc21.noarch.rpm
docker-compose.noarch: W: no-manual-page-for-binary docker-compose
2 packages and 1 specfiles checked; 0 errors, 1 warnings.

(Upstream does not ship a man page.)

Currently the package builds on all Fedora except for fedora-20-i386, and on EPEL, all of which are missing necessary dependencies. 

Fedora Account System Username: error

Comment 1 Pranav Kant 2015-04-19 09:34:50 UTC
I am not sure, does the LICENSE file will go to both %doc and %license ?

I think it should be removed from %doc.

Comment 2 Michael Hampton 2015-04-19 15:51:32 UTC
(In reply to Pranav Kant from comment #1)
> I am not sure, does the LICENSE file will go to both %doc and %license ?
> 
> I think it should be removed from %doc.

Good catch. I've removed the extra one from %doc, and the result is:

Spec URL: https://dl.dropboxusercontent.com/u/24777749/docker-compose.spec
SRPM URL: https://dl.dropboxusercontent.com/u/24777749/docker-compose-1.2.0-2.fc21.src.rpm
Scratch build: https://copr.fedoraproject.org/coprs/error/docker-compose/build/86905/

Comment 3 Marek Goldmann 2015-04-23 06:33:43 UTC
I'm going to review it, sorry for the delay.

Comment 4 Marek Goldmann 2015-05-15 15:35:12 UTC
Package Review
==============

Legend:
[x] = Pass, [!] = Fail, [-] = Not applicable, [?] = Not evaluated
[ ] = Manual review needed



===== MUST items =====

Generic:
[x]: Package is licensed with an open-source compatible license and meets
     other legal requirements as defined in the legal section of Packaging
     Guidelines.
[x]: License field in the package spec file matches the actual license.
[x]: Package contains no bundled libraries without FPC exception.
[x]: Changelog in prescribed format.
[x]: Sources contain only permissible code or content.
[-]: Package contains desktop file if it is a GUI application.
[-]: Development files must be in a -devel package
[x]: Package uses nothing in %doc for runtime.
[x]: Package consistently uses macros (instead of hard-coded directory
     names).
[x]: Package is named according to the Package Naming Guidelines.
[x]: Package does not generate any conflict.
[x]: Package obeys FHS, except libexecdir and /usr/target.
[x]: If the package is a rename of another package, proper Obsoletes and
     Provides are present.
[x]: Requires correct, justified where necessary.
[x]: Spec file is legible and written in American English.
[-]: Package contains systemd file(s) if in need.
[x]: Package is not known to require an ExcludeArch tag.
[x]: Large documentation must go in a -doc subpackage. Large could be size
     (~1MB) or number of files.
     Note: Documentation size is 30720 bytes in 4 files.
[x]: Package complies to the Packaging Guidelines
[x]: Package successfully compiles and builds into binary rpms on at least
     one supported primary architecture.
[x]: Package installs properly.
[x]: Rpmlint is run on all rpms the build produces.
     Note: There are rpmlint messages (see attachment).
[x]: If (and only if) the source package includes the text of the
     license(s) in its own file, then that file, containing the text of the
     license(s) for the package is included in %license.
[x]: Package requires other packages for directories it uses.
[x]: Package must own all directories that it creates.
[x]: Package does not own files or directories owned by other packages.
[x]: All build dependencies are listed in BuildRequires, except for any
     that are listed in the exceptions section of Packaging Guidelines.
[x]: Package uses either %{buildroot} or $RPM_BUILD_ROOT
[x]: Package does not run rm -rf %{buildroot} (or $RPM_BUILD_ROOT) at the
     beginning of %install.
[x]: Macros in Summary, %description expandable at SRPM build time.
[x]: Dist tag is present.
[x]: Package does not contain duplicates in %files.
[x]: Permissions on files are set properly.
[x]: Package use %makeinstall only when make install DESTDIR=... doesn't
     work.
[x]: Package is named using only allowed ASCII characters.
[x]: Package does not use a name that already exists.
[x]: Package is not relocatable.
[x]: Sources used to build the package match the upstream source, as
     provided in the spec URL.
[x]: Spec file name must match the spec package %{name}, in the format
     %{name}.spec.
[x]: File names are valid UTF-8.
[x]: Packages must not store files under /srv, /opt or /usr/local

Python:
[x]: Python eggs must not download any dependencies during the build
     process.
[x]: A package which is used by another package via an egg interface should
     provide egg info.
[x]: Package meets the Packaging Guidelines::Python
[x]: Package contains BR: python2-devel or python3-devel
[x]: Binary eggs must be removed in %prep

===== SHOULD items =====

Generic:
[x]: If the source package does not include license text(s) as a separate
     file from upstream, the packager SHOULD query upstream to include it.
[x]: Final provides and requires are sane (see attachments).
[x]: Package functions as described.
[x]: Latest version is packaged.
[x]: Package does not include license text files separate from upstream.
[-]: Patches link to upstream bugs/comments/lists or are otherwise
     justified.
[x]: Description and summary sections in the package spec file contains
     translations for supported Non-English languages, if available.
[x]: Package should compile and build into binary rpms on all supported
     architectures.
[-]: %check is present and all tests pass.
[x]: Packages should try to preserve timestamps of original installed
     files.
[x]: Packager, Vendor, PreReq, Copyright tags should not be in spec file
[x]: Sources can be downloaded from URI in Source: tag
[x]: Reviewer should test that the package builds in mock.
[x]: Buildroot is not present
[x]: Package has no %clean section with rm -rf %{buildroot} (or
     $RPM_BUILD_ROOT)
[x]: No file requires outside of /etc, /bin, /sbin, /usr/bin, /usr/sbin.
[x]: SourceX is a working URL.
[x]: Spec use %global instead of %define unless justified.

===== EXTRA items =====

Generic:
[x]: Rpmlint is run on all installed packages.
     Note: There are rpmlint messages (see attachment).
[x]: Spec file according to URL is the same as in SRPM.


Rpmlint
-------
Checking: docker-compose-1.2.0-2.fc23.noarch.rpm
          docker-compose-1.2.0-2.fc23.src.rpm
docker-compose.noarch: W: no-manual-page-for-binary docker-compose
2 packages and 0 specfiles checked; 0 errors, 1 warnings.




Rpmlint (installed packages)
----------------------------
docker-compose.noarch: W: no-manual-page-for-binary docker-compose
1 packages and 0 specfiles checked; 0 errors, 1 warnings.



Requires
--------
docker-compose (rpmlib, GLIBC filtered):
    /usr/bin/python2
    PyYAML
    python(abi)
    python-docker-py
    python-dockerpty
    python-docopt
    python-requests
    python-setuptools
    python-six
    python-texttable
    python-websocket-client



Provides
--------
docker-compose:
    docker-compose
    fig



Source checksums
----------------
https://pypi.python.org/packages/source/d/docker-compose/docker-compose-1.2.0.tar.gz :
  CHECKSUM(SHA256) this package     : 46ef3c5cb7dd79fa7fd1d5fc5ec5be6a5c634192bc09c604c0ea75adb89cb652
  CHECKSUM(SHA256) upstream package : 46ef3c5cb7dd79fa7fd1d5fc5ec5be6a5c634192bc09c604c0ea75adb89cb652


Generated by fedora-review 0.5.3 (bcf15e3) last change: 2015-05-04
Command line :/usr/bin/fedora-review -v -m fedora-rawhide-x86_64 -b 1213111
Buildroot used: fedora-rawhide-x86_64
Active plugins: Python, Generic, Shell-api
Disabled plugins: Java, C/C++, fonts, SugarActivity, Ocaml, Perl, Haskell, R, PHP, Ruby
Disabled flags: EXARCH, DISTTAG, EPEL5, BATCH, EPEL6

Build fine in Rawhide.

In general this package looks good!

Issues:

1. In Obsoletes you're missing release number as per docs:

  https://fedoraproject.org/wiki/Packaging:Guidelines#Renaming.2FReplacing_Existing_Packages

set it to Release+1 and use <=, like this:

Obsoletes: fig <= 1.0.1-2

2. Why you don't build Python 3 package? You can take a look what's required here: https://goldmann.fedorapeople.org/package_review/python-docker-scripts/3/python-docker-scripts.spec

Question: In what branches you want to update the package?

Please make sure you work with mstuchli to properly remove the package from Rawhide: https://fedoraproject.org/wiki/Upgrade_paths_%E2%80%94_renaming_or_splitting_packages.

Comment 5 Michael Hampton 2015-05-15 18:20:58 UTC
I'm not building Python 3 packages because upstream claims to not yet be Python 3 compatible (upstream bug: https://github.com/docker/compose/issues/219)

I want to update all Fedora branches (f20, f21, f22, f23/rawhide) as the old version of fig no longer talks to the current version of docker, claiming an API incompatibility. Which is what started this whole odyssey in the first place.

I've added a Release to Obsoletes: and I'm running a new build now to shake loose any last minute issues I might have missed or forgotten about.

Comment 6 Michael Hampton 2015-05-15 23:08:36 UTC
Spec URL: https://dl.dropboxusercontent.com/u/24777749/docker-compose.spec
SRPM URL: https://kojipkgs.fedoraproject.org//work/tasks/7473/9757473/docker-compose-1.2.0-3.fc23.src.rpm
Scratch builds:
- F23: http://koji.fedoraproject.org/koji/taskinfo?taskID=9757473
- F22: http://koji.fedoraproject.org/koji/taskinfo?taskID=9757956
- F21: http://koji.fedoraproject.org/koji/taskinfo?taskID=9757962
- F20: http://koji.fedoraproject.org/koji/taskinfo?taskID=9757970

F20 build failed because python-docker-py is missing on i386 (but present on x86_64). I'd like to fix this but won't be terribly concerned since F20 will be EOL very soon.

This same package is also too old on F21; docker-compose 1.2 requires python-docker-py version 1.0.0 but F21 has 0.7.1. This causes docker-compose's --timeout option to fail with the exception "AttributeError: 'Client' object has no attribute 'timeout'". This was the only testsuite failure I encountered. Atomic also uses the python-docker-py package, so it might not be safe to upgrade this.

Looking forward, the upcoming 1.3 release of docker-compose will require python-dockerpty 0.3.3, but only 0.2.3 is currently in any version of Fedora. 1.2 also works with python-dockerpty 0.3.3. As docker-compose (formerly fig) is currently the only Fedora package using python-dockerpty, it should be safe to upgrade this.

Comment 7 Lokesh Mandvekar 2015-07-17 16:27:09 UTC
Hi Marek, can we please get this one moving?

Comment 8 Lokesh Mandvekar 2015-07-17 16:28:58 UTC
Michael, hope you're still interested in getting this in, if it helps makes things easier, just 1 scratch build for the latest stable or rawhide should be fine for package reviews.

Comment 9 Michael Hampton 2015-07-17 17:02:01 UTC
Oh yes I'm still interested. I will create new scratch builds shortly as it seems the ones above are no longer in koji.

Comment 11 Marek Goldmann 2015-08-07 08:29:36 UTC
Looks good, APPROVED!

I'm very sorry it took so long...

Comment 12 Michael Hampton 2015-08-09 15:39:46 UTC
New Package SCM Request
=======================
Package Name: docker-compose
Short Description: Punctual, lightweight development environments using Docker
Upstream URL: https://www.docker.com/
Owners: error lsm5
Branches: f22 f23
InitialCC:

Comment 13 Gwyn Ciesla 2015-08-10 14:13:08 UTC
Git done (by process-git-requests).

Comment 14 Fedora Update System 2015-08-10 17:43:50 UTC
docker-compose-1.2.0-3.fc23 has been submitted as an update for Fedora 23.
https://admin.fedoraproject.org/updates/docker-compose-1.2.0-3.fc23

Comment 15 Fedora Update System 2015-08-10 17:45:28 UTC
docker-compose-1.2.0-3.fc22 has been submitted as an update for Fedora 22.
https://admin.fedoraproject.org/updates/docker-compose-1.2.0-3.fc22

Comment 16 Fedora Update System 2015-08-12 01:13:07 UTC
docker-compose-1.4.0-1.fc23 has been submitted as an update for Fedora 23.
https://admin.fedoraproject.org/updates/docker-compose-1.4.0-1.fc23

Comment 17 Fedora Update System 2015-08-12 06:56:47 UTC
docker-compose-1.2.0-3.fc22 has been pushed to the Fedora 22 testing repository.

Comment 18 Fedora Update System 2015-08-22 02:52:11 UTC
docker-compose-1.2.0-3.fc22 has been pushed to the Fedora 22 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update docker-compose'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-13183

Comment 19 Fedora Update System 2015-08-22 16:26:37 UTC
docker-compose-1.4.0-1.fc23 has been pushed to the Fedora 23 testing repository. If problems still persist, please make note of it in this bug report.\nIf you want to test the update, you can install it with \n su -c 'yum --enablerepo=updates-testing update docker-compose'. You can provide feedback for this update here: https://bodhi.fedoraproject.org/updates/FEDORA-2015-13300

Comment 20 Fedora Update System 2015-09-06 01:11:07 UTC
docker-compose-1.4.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.

Comment 21 Fedora Update System 2015-09-06 04:50:33 UTC
docker-compose-1.2.0-3.fc22 has been pushed to the Fedora 22 stable repository. If problems still persist, please make note of it in this bug report.

Comment 22 Fedora Update System 2015-09-06 17:06:30 UTC
docker-compose-1.4.0-1.fc23 has been pushed to the Fedora 23 stable repository. If problems still persist, please make note of it in this bug report.


Note You need to log in before you can comment on or make changes to this bug.